datablock fxDTSBrickData(brick2x2ScreenBrickData)
{
	brickFile = "Add-Ons/Brick_ScreenBricks/screenBrick.blb";
	category = "Special"; 
	subCategory = "Misc";
	uiName = "2x2 Screen Brick";                  
	iconName = "Add-Ons/Brick_ScreenBricks/screenBrick";
    hasPrint = 0;
    orientationFix = 3;
    isScreenBrick = true;
};

package ScreenBrick2x2OverridesPackage
{
	function fxDTSBrick::onRemove(%this)
	{
		if($Pref::Server::Quota::ScreenBricks > 75)
			$Pref::Server::Quota::ScreenBricks = 75;

		if($Pref::Server::Quota::ScreenBricksAdmin > 75)
			$Pref::Server::Quota::ScreenBricksAdmin = 75;

		%this.clearPixels();

		if(%this.dataBlock $= "brick2x2ScreenBrickData" && %this.screenPlanted)
			getBrickGroupFromObject(%this).screenBricks--;

		if(%this.dataBlock $= "brick3x3ScreenBrickData" && %this.screenPlanted)
			getBrickGroupFromObject(%this).screenBricks -= 2.25;

		if(getBrickGroupFromObject(%this).screenBricks < 0)
			getBrickGroupFromObject(%this).screenBricks = 0;

		Parent::onRemove(%this);
	}

	function fxDTSBrick::onDeath(%this)
	{
		if($Pref::Server::Quota::ScreenBricks > 75)
			$Pref::Server::Quota::ScreenBricks = 75;

		if($Pref::Server::Quota::ScreenBricksAdmin > 75)
			$Pref::Server::Quota::ScreenBricksAdmin = 75;

		%this.clearPixels();

		Parent::onDeath(%this);
	}

	function fxDTSBrick::onPlant(%this)
	{
		Parent::onPlant(%this);

		%this.screenPlanted = true; // onRemove is called even when a brick fails to plant, so this is to prevent people from circumventing the quota

		if($Pref::Server::Quota::ScreenBricks > 75)
			$Pref::Server::Quota::ScreenBricks = 75;

		if($Pref::Server::Quota::ScreenBricksAdmin > 75)
			$Pref::Server::Quota::ScreenBricksAdmin = 75;

		if(getBrickGroupFromObject(%this).screenBricks < 0)
			getBrickGroupFromObject(%this).screenBricks = 0;

		if(%this.dataBlock.isScreenBrick)
			%this.createPixels();
	}

	function fxDTSBrick::onLoadPlant(%this)
	{
		Parent::onLoadPlant(%this);

		%this.screenPlanted = true;

		if($Pref::Server::Quota::ScreenBricks > 75)
			$Pref::Server::Quota::ScreenBricks = 75;

		if($Pref::Server::Quota::ScreenBricksAdmin > 75)
			$Pref::Server::Quota::ScreenBricksAdmin = 75;


		if(getBrickGroupFromObject(%this).screenBricks < 0)
			getBrickGroupFromObject(%this).screenBricks = 0;

		if(%this.dataBlock.isScreenBrick)
			%this.createPixels();
	}
};
activatePackage(ScreenBrick2x2OverridesPackage);

function fxDTSBrick::createPixels(%this)
{
	if($Pref::Server::Quota::ScreenBricks > 75)
		$Pref::Server::Quota::ScreenBricks = 75;

	if($Pref::Server::Quota::ScreenBricksAdmin > 75)
		$Pref::Server::Quota::ScreenBricksAdmin = 75;


	if(%this.dataBlock.isScreenBrick)
	{
		%brickGroup = getBrickGroupFromObject(%this);

		if(%this.dataBlock $= "brick2x2ScreenBrickData")
			%brickGroup.screenBricks++;

		if(isObject(%brickGroup.client))
		{
			%client = %brickGroup.client;

			if((%brickGroup.screenBricks >= $Pref::Server::Quota::ScreenBricks && !%client.isAdmin) ||
				%brickGroup.screenBricks >= $Pref::Server::Quota::ScreenBricksAdmin)
			{
				if(isObject(%client.player))
					%client.centerPrint("Screen limit reached.", 2);
				
				return;
			}
		}

		if(%brickGroup.screenBricks >= $Pref::Server::Quota::ScreenBricksAdmin)
			return;

		if(isObject(%client))
		{
			if(!%client.isAdmin && %brickGroup.screenBricks >= $Pref::Server::Quota::ScreenBricks && %this.dataBlock.isScreenBrick)
				return;
			
			if(%brickGroup.screenBricks >= $Pref::Server::Quota::ScreenBricksAdmin && %this.dataBlock.isScreenBrick)
				return;
		}
		else
		{
			if(!%client.isAdmin && %brickGroup.screenBricks >= $Pref::Server::Quota::ScreenBricks && %this.dataBlock.isScreenBrick)
				return;
			
			if(%brickGroup.screenBricks >= $Pref::Server::Quota::ScreenBricksAdmin && %this.dataBlock.isScreenBrick)
				return;
		}

		if(%this.dataBlock $= "brick2x2ScreenBrickData")
		{
			if(%this.rotation $= "0 0 1 90.0002" || %this.rotation $= "0 0 1 90")
			{
				%position0 = vectorAdd(%this.getPosition(), "-0.75 0.125 0.15");
				%position1 = vectorAdd(%this.getPosition(), "-0.75 -0.125 0.15");
				%position2 = vectorAdd(%this.getPosition(), "-0.75 0.125 -0.15");
				%position3 = vectorAdd(%this.getPosition(), "-0.75 -0.125 -0.15");
					
				%rotation = "0 1 0 90";
			}

			else if(%this.rotation $= "0 0 -1 90.0002" || %this.rotation $= "0 0 -1 90")
			{
				%position0 = vectorAdd(%this.getPosition(), "0.75 -0.125 0.15");
				%position1 = vectorAdd(%this.getPosition(), "0.75 0.125 0.15");
				%position2 = vectorAdd(%this.getPosition(), "0.75 -0.125 -0.15");
				%position3 = vectorAdd(%this.getPosition(), "0.75 0.125 -0.15");
					
				%rotation = "0 -1 0 90";
			}

			else if(%this.rotation $= "1 0 0 0" || %this.rotation $= "0 0 0 0")
			{
				%position0 = vectorAdd(%this.getPosition(), "-0.125 -0.75 0.15");
				%position1 = vectorAdd(%this.getPosition(), "0.125 -0.75 0.15");
				%position2 = vectorAdd(%this.getPosition(), "-0.125 -0.75 -0.15");
				%position3 = vectorAdd(%this.getPosition(), "0.125 -0.75 -0.15");
					
				%rotation = "1 1 1 90";
			}

			else if(%this.rotation $= "0 0 1 180")
			{
				%position0 = vectorAdd(%this.getPosition(), "0.125 0.75 0.15");
				%position1 = vectorAdd(%this.getPosition(), "-0.125 0.75 0.15");
				%position2 = vectorAdd(%this.getPosition(), "0.125 0.75 -0.15");
				%position3 = vectorAdd(%this.getPosition(), "-0.125 0.75 -0.15");
					
				%rotation = "-1 1 -1 90";
			}
			else
				return;

			%this.pixel[0] = new StaticShape()
	        {
	            datablock = FlatPlaneShape;

	            color = "1 1 1 1";

	            position = %position0;
	            rotation = %rotation;
	            scale = "0.75 0.625 0.625";
	        };
	        missionCleanup.add(%this.pixel[0]);

	        %this.pixel[1] = new StaticShape()
	        {
	            datablock = FlatPlaneShape;

	            color = "1 1 1 1";

	            position = %position1;
	            rotation = %rotation;
	            scale = "0.75 0.625 0.625";
	        };
	        missionCleanup.add(%this.pixel[1]);

	        %this.pixel[2] = new StaticShape()
	        {
	            datablock = FlatPlaneShape;

	            color = "1 1 1 1";

	            position = %position2;
	            rotation = %rotation;
	            scale = "0.75 0.625 0.625";
	        };
	        missionCleanup.add(%this.pixel[2]);

	        %this.pixel[3] = new StaticShape()
	        {
	            datablock = FlatPlaneShape;

	            color = "1 1 1 1";

	            position = %position3;
	            rotation = %rotation;
	            scale = "0.75 0.625 0.625";
	        };
		}
	}
}

exec("./3x3.cs");

function fxDTSBrick::clearPixels(%this)
{
	if(isObject(%this.pixel[0]))
	{
		%this.pixel[0].delete();
		//getBrickGroupFromObject(%this).screenBrickPixelCount--; // nah
	}

	if(isObject(%this.pixel[1]))
	{
		%this.pixel[1].delete();
		//getBrickGroupFromObject(%this).screenBrickPixelCount--;
	}

	if(isObject(%this.pixel[2]))
	{
		%this.pixel[2].delete();
		//getBrickGroupFromObject(%this).screenBrickPixelCount--;
	}

	if(isObject(%this.pixel[3]))
	{
		%this.pixel[3].delete();
		//getBrickGroupFromObject(%this).screenBrickPixelCount--;
	}

	if(isObject(%this.pixel[4]))
	{
		%this.pixel[4].delete();
		//getBrickGroupFromObject(%this).screenBrickPixelCount--;
	}

	if(isObject(%this.pixel[5]))
	{
		%this.pixel[5].delete();
		//getBrickGroupFromObject(%this).screenBrickPixelCount--;
	}

	if(isObject(%this.pixel[6]))
	{
		%this.pixel[6].delete();
		//getBrickGroupFromObject(%this).screenBrickPixelCount--;
	}

	if(isObject(%this.pixel[7]))
	{
		%this.pixel[7].delete();
		//getBrickGroupFromObject(%this).screenBrickPixelCount--;
	}

	if(isObject(%this.pixel[8]))
	{
		%this.pixel[8].delete();
		//getBrickGroupFromObject(%this).screenBrickPixelCount--;
	}
}