datablock fxDTSBrickData(brick3x3ScreenBrickData)
{
	brickFile = "Add-Ons/Brick_ScreenBricks/screenBrick.blb";
	category = "Special"; 
	subCategory = "Misc";
	uiName = "3x3 Screen Brick";                  
	iconName = "Add-Ons/Brick_ScreenBricks/screenBrick";
    hasPrint = 0;
    orientationFix = 3;
    isScreenBrick = true;
};

package ScreenBrick3x3OverridesPackage
{
	function fxDTSBrick::createPixels(%this)
	{
		Parent::createPixels(%this);

		if(%this.dataBlock.isScreenBrick)
		{
			%brickGroup = getBrickGroupFromObject(%this);

			if(%this.dataBlock $= "brick3x3ScreenBrickData")
				%brickGroup.screenBricks += 2.25;

			if(isObject(%brickGroup.client))
			{
				%client = %brickGroup.client;

				if((%brickGroup.screenBricks >= $Pref::Server::Quota::ScreenBricks && !%client.isAdmin) ||
					%brickGroup.screenBricks >= $Pref::Server::Quota::ScreenBricksAdmin)
				{
					if(isObject(%client.player))
						%client.centerPrint("Screen limit reached.", 2);
					
					return;
				}
			}

			if(%brickGroup.screenBricks >= $Pref::Server::Quota::ScreenBricksAdmin)
				return;

			if(isObject(%client))
			{
				if(!%client.isAdmin && %brickGroup.screenBricks >= $Pref::Server::Quota::ScreenBricks && %this.dataBlock.isScreenBrick)
					return;
				
				if(%brickGroup.screenBricks >= $Pref::Server::Quota::ScreenBricksAdmin && %this.dataBlock.isScreenBrick)
					return;
			}
			else
			{
				if(!%client.isAdmin && %brickGroup.screenBricks >= $Pref::Server::Quota::ScreenBricks && %this.dataBlock.isScreenBrick)
					return;
				
				if(%brickGroup.screenBricks >= $Pref::Server::Quota::ScreenBricksAdmin && %this.dataBlock.isScreenBrick)
					return;
			}

			if(%this.dataBlock $= "brick3x3ScreenBrickData")
			{
				if(%this.rotation $= "0 0 1 90.0002" || %this.rotation $= "0 0 1 90")
				{
					%position0 = vectorAdd(%this.getPosition(), "-0.75 -0.166666 0.2");
					%position1 = vectorAdd(%this.getPosition(), "-0.75 0 0.2");
					%position2 = vectorAdd(%this.getPosition(), "-0.75 0.166666 0.2");

					%position3 = vectorAdd(%this.getPosition(), "-0.75 -0.166666 0");
					%position4 = vectorAdd(%this.getPosition(), "-0.75 0 0");
					%position5 = vectorAdd(%this.getPosition(), "-0.75 0.166666 0");

					%position6 = vectorAdd(%this.getPosition(), "-0.75 -0.166666 -0.2");
					%position7 = vectorAdd(%this.getPosition(), "-0.75 0 -0.2");
					%position8 = vectorAdd(%this.getPosition(), "-0.75 0.166666 -0.2");

					%rotation = "0 1 0 90";
				}

				else if(%this.rotation $= "0 0 -1 90.0002" || %this.rotation $= "0 0 -1 90")
				{
					%position0 = vectorAdd(%this.getPosition(), "0.75 -0.166666 0.2");
					%position1 = vectorAdd(%this.getPosition(), "0.75 0 0.2");
					%position2 = vectorAdd(%this.getPosition(), "0.75 0.166666 0.2");

					%position3 = vectorAdd(%this.getPosition(), "0.75 -0.166666 0");
					%position4 = vectorAdd(%this.getPosition(), "0.75 0 0");
					%position5 = vectorAdd(%this.getPosition(), "0.75 0.166666 0");

					%position6 = vectorAdd(%this.getPosition(), "0.75 -0.166666 -0.2");
					%position7 = vectorAdd(%this.getPosition(), "0.75 0 -0.2");
					%position8 = vectorAdd(%this.getPosition(), "0.75 0.166666 -0.2");
					
					%rotation = "0 -1 0 90";
				}

				else if(%this.rotation $= "1 0 0 0" || %this.rotation $= "0 0 0 0")
				{
					%position0 = vectorAdd(%this.getPosition(), "-0.166666 -0.75 0.2");
					%position1 = vectorAdd(%this.getPosition(), "0 -0.75 0.2");
					%position2 = vectorAdd(%this.getPosition(), "0.166666 -0.75 0.2");

					%position3 = vectorAdd(%this.getPosition(), "-0.166666 -0.75 0");
					%position4 = vectorAdd(%this.getPosition(), "0 -0.75 0");
					%position5 = vectorAdd(%this.getPosition(), "0.166666 -0.75 0");

					%position6 = vectorAdd(%this.getPosition(), "-0.166666 -0.75 -0.2");
					%position7 = vectorAdd(%this.getPosition(), "0 -0.75 -0.2");
					%position8 = vectorAdd(%this.getPosition(), "0.166666 -0.75 -0.2");
					
					%rotation = "1 1 1 90";
				}

				else if(%this.rotation $= "0 0 1 180")
				{
					%position0 = vectorAdd(%this.getPosition(), "-0.166666 0.75 0.2");
					%position1 = vectorAdd(%this.getPosition(), "0 0.75 0.2");
					%position2 = vectorAdd(%this.getPosition(), "0.166666 0.75 0.2");

					%position3 = vectorAdd(%this.getPosition(), "-0.166666 0.75 0");
					%position4 = vectorAdd(%this.getPosition(), "0 0.75 0");
					%position5 = vectorAdd(%this.getPosition(), "0.166666 0.75 0");

					%position6 = vectorAdd(%this.getPosition(), "-0.166666 0.75 -0.2");
					%position7 = vectorAdd(%this.getPosition(), "0 0.75 -0.2");
					%position8 = vectorAdd(%this.getPosition(), "0.166666 0.75 -0.2");
					
					%rotation = "-1 1 -1 90";
				}
				else
					return;

				%scale = "0.5 0.416666 0.416666";

				%this.pixel[0] = new StaticShape()
	            {
	                datablock = FlatPlaneShape;

	                color = "1 1 1 1";

	                position = %position0;
	                rotation = %rotation;
	                scale = %scale;
	            };
	            missionCleanup.add(%this.pixel[0]);

	            %this.pixel[1] = new StaticShape()
	            {
	                datablock = FlatPlaneShape;

	                color = "1 1 1 1";

	                position = %position1;
	                rotation = %rotation;
	                scale = %scale;
	            };
	            missionCleanup.add(%this.pixel[1]);

	            %this.pixel[2] = new StaticShape()
	            {
	                datablock = FlatPlaneShape;

	                color = "1 1 1 1";

	                position = %position2;
	                rotation = %rotation;
	                scale = %scale;
	            };
	            missionCleanup.add(%this.pixel[2]);

	            %this.pixel[3] = new StaticShape()
	            {
	                datablock = FlatPlaneShape;

	                color = "1 1 1 1";

	                position = %position3;
	                rotation = %rotation;
	                scale = %scale;
	            };
	            missionCleanup.add(%this.pixel[3]);

	            %this.pixel[4] = new StaticShape()
	            {
	                datablock = FlatPlaneShape;

	                color = "1 1 1 1";

	                position = %position4;
	                rotation = %rotation;
	                scale = %scale;
	            };
	            missionCleanup.add(%this.pixel[4]);  
			
	            %this.pixel[5] = new StaticShape()
	            {
	                datablock = FlatPlaneShape;

	                color = "1 1 1 1";

	                position = %position5;
	                rotation = %rotation;
	                scale = %scale;
	            };
	            missionCleanup.add(%this.pixel[5]);  

	            %this.pixel[6] = new StaticShape()
	            {
	                datablock = FlatPlaneShape;

	                color = "1 1 1 1";

	                position = %position6;
	                rotation = %rotation;
	                scale = %scale;
	            };
	            missionCleanup.add(%this.pixel[6]);  

	            %this.pixel[7] = new StaticShape()
	            {
	                datablock = FlatPlaneShape;

	                color = "1 1 1 1";

	                position = %position7;
	                rotation = %rotation;
	                scale = %scale;
	            };
	            missionCleanup.add(%this.pixel[7]);  

	            %this.pixel[8] = new StaticShape()
	            {
	                datablock = FlatPlaneShape;

	                color = "1 1 1 1";

	                position = %position8;
	                rotation = %rotation;
	                scale = %scale;
	            };
	            missionCleanup.add(%this.pixel[8]);  
			}
		}
	}

	function fxDTSBrick::setPixelColors(%this, %pixel0, %pixel1, %pixel2, %pixel3)
	{
		Parent::setPixelColors(%this, %pixel0, %pixel1, %pixel2, %pixel3);

		if(%this.dataBlock $= "brick3x3ScreenBrickData")
		{
			if(isObject(%this.pixel[0]) && %pixel0 !$= "" && getWordCount(%pixel0) >= 4)
			{
				if(getWord(getWords(%pixel0, 0, 3), 3) <= 0 && getWord(getWords(%pixel0, 0, 3), 3) !$= "r")
					%this.pixel[0].hideNode("ALL");
				else if(getWord(getWords(%pixel0, 0, 3), 3) !$= "r")
				{
					%color = pixelRGBToDec(getWords(%pixel0, 0, 3));

					if(getWord(getWords(%pixel0, 0, 3), 3) <= 0)
						%this.pixel[0].hideNode("ALL");
					else
					{
						%this.pixel[0].setNodeColor("ALL", %color);
						%this.pixel[0].unhideNode("ALL");
					}
				}
				else
				{
					%this.pixel[0].setNodeColor("ALL", pixelRGBToDec(getWords(%pixel0, 0, 3)));
					%this.pixel[0].unhideNode("ALL");
				}
			}
			
			if(isObject(%this.pixel[1]) && %pixel0 !$= "" && getWordCount(%pixel0) >= 4)
			{
				if(getWord(getWords(%pixel0, 4, 7), 3) <= 0 && getWord(getWords(%pixel0, 4, 7), 3) !$= "r")
					%this.pixel[1].hideNode("ALL");
				else if(getWord(getWords(%pixel0, 4, 7), 3) !$= "r")
				{
					%color = pixelRGBToDec(getWords(%pixel0, 4, 7));

					if(getWord(getWords(%pixel0, 4, 7), 3) <= 0)
						%this.pixel[1].hideNode("ALL");
					else
					{
						%this.pixel[1].setNodeColor("ALL", %color);
						%this.pixel[1].unhideNode("ALL");
					}
				}
				else
				{
					%this.pixel[1].setNodeColor("ALL", pixelRGBToDec(getWords(%pixel0, 4, 7)));
					%this.pixel[1].unhideNode("ALL");
				}
			}

			if(isObject(%this.pixel[2]) && %pixel0 !$= "" && getWordCount(%pixel0) >= 4)
			{
				if(getWord(getWords(%pixel0, 8, 11), 3) <= 0 && getWord(getWords(%pixel0, 8, 11), 3) !$= "r")
					%this.pixel[2].hideNode("ALL");
				else if(getWord(getWords(%pixel0, 8, 11), 3) !$= "r")
				{
					%color = pixelRGBToDec(getWords(%pixel0, 8, 11));

					if(getWord(getWords(%pixel0, 8, 11), 3) <= 0)
						%this.pixel[2].hideNode("ALL");
					else
					{
						%this.pixel[2].setNodeColor("ALL", %color);
						%this.pixel[2].unhideNode("ALL");
					}
				}
				else
				{
					%this.pixel[2].setNodeColor("ALL", pixelRGBToDec(getWords(%pixel0, 8, 11)));
					%this.pixel[2].unhideNode("ALL");
				}
			}

			if(isObject(%this.pixel[3]) && %pixel1 !$= "" && getWordCount(%pixel1) >= 4)
			{
				if(getWord(getWords(%pixel1, 0, 3), 3) <= 0 && getWord(getWords(%pixel1, 0, 3), 3) !$= "r")
					%this.pixel[3].hideNode("ALL");
				else if(getWord(getWords(%pixel1, 0, 3), 3) !$= "r")
				{
					%color = pixelRGBToDec(getWords(%pixel1, 0, 3));

					if(getWord(getWords(%pixel1, 0, 3), 3) <= 0)
						%this.pixel[3].hideNode("ALL");
					else
					{
						%this.pixel[3].setNodeColor("ALL", %color);
						%this.pixel[3].unhideNode("ALL");
					}
				}
				else
				{
					%this.pixel[3].setNodeColor("ALL", pixelRGBToDec(getWords(%pixel1, 0, 3)));
					%this.pixel[3].unhideNode("ALL");
				}
			}

			if(isObject(%this.pixel[4]) && %pixel1 !$= "" && getWordCount(%pixel1) >= 4)
			{
				if(getWord(getWords(%pixel1, 4, 7), 3) <= 0 && getWord(getWords(%pixel1, 4, 7), 3) !$= "r")
					%this.pixel[4].hideNode("ALL");
				else if(getWord(getWords(%pixel1, 4, 7), 3) !$= "r")
				{
					%color = pixelRGBToDec(getWords(%pixel1, 4, 7));

					if(getWord(getWords(%pixel1, 4, 7), 3) <= 0)
						%this.pixel[4].hideNode("ALL");
					else
					{
						%this.pixel[4].setNodeColor("ALL", %color);
						%this.pixel[4].unhideNode("ALL");
					}
				}
				else
				{
					%this.pixel[4].setNodeColor("ALL", pixelRGBToDec(getWords(%pixel1, 4, 7)));
					%this.pixel[4].unhideNode("ALL");
				}
			}

			if(isObject(%this.pixel[5]) && %pixel1 !$= "" && getWordCount(%pixel1) >= 4)
			{
				if(getWord(getWords(%pixel1, 8, 11), 3) <= 0 && getWord(getWords(%pixel1, 8, 11), 3) !$= "r")
					%this.pixel[5].hideNode("ALL");
				else if(getWord(getWords(%pixel1, 8, 11), 3) !$= "r")
				{
					%color = pixelRGBToDec(getWords(%pixel1, 8, 11));

					if(getWord(getWords(%pixel1, 8, 11), 3) <= 0)
						%this.pixel[5].hideNode("ALL");
					else
					{
						%this.pixel[5].setNodeColor("ALL", %color);
						%this.pixel[5].unhideNode("ALL");
					}
				}
				else
				{
					%this.pixel[5].setNodeColor("ALL", pixelRGBToDec(getWords(%pixel1, 8, 11)));
					%this.pixel[5].unhideNode("ALL");
				}
			}

			if(isObject(%this.pixel[6]) && %pixel2 !$= "" && getWordCount(%pixel2) >= 4)
			{
				if(getWord(getWords(%pixel2, 0, 3), 3) <= 0 && getWord(getWords(%pixel2, 0, 3), 3) !$= "r")
					%this.pixel[6].hideNode("ALL");
				else if(getWord(getWords(%pixel2, 0, 3), 3) !$= "r")
				{
					%color = pixelRGBToDec(getWords(%pixel2, 0, 3));

					if(getWord(getWords(%pixel2, 0, 3), 3) <= 0)
						%this.pixel[6].hideNode("ALL");
					else
					{
						%this.pixel[6].setNodeColor("ALL", %color);
						%this.pixel[6].unhideNode("ALL");
					}
				}
				else
				{
					%this.pixel[6].setNodeColor("ALL", pixelRGBToDec(getWords(%pixel2, 0, 3)));
					%this.pixel[6].unhideNode("ALL");
				}
			}

			if(isObject(%this.pixel[7]) && %pixel2 !$= "" && getWordCount(%pixel2) >= 4)
			{
				if(getWord(getWords(%pixel2, 4, 7), 3) <= 0 && getWord(getWords(%pixel2, 4, 7), 3) !$= "r")
					%this.pixel[7].hideNode("ALL");
				else if(getWord(getWords(%pixel2, 4, 7), 3) !$= "r")
				{
					%color = pixelRGBToDec(getWords(%pixel2, 4, 7));

					if(getWord(getWords(%pixel2, 4, 7), 3) <= 0)
						%this.pixel[7].hideNode("ALL");
					else
					{
						%this.pixel[7].setNodeColor("ALL", %color);
						%this.pixel[7].unhideNode("ALL");
					}
				}
				else
				{
					%this.pixel[7].setNodeColor("ALL", pixelRGBToDec(getWords(%pixel2, 4, 7)));
					%this.pixel[7].unhideNode("ALL");
				}
			}

			if(isObject(%this.pixel[8]) && %pixel2 !$= "" && getWordCount(%pixel2) >= 4)
			{
				if(getWord(getWords(%pixel2, 8, 11), 3) <= 0 && getWord(getWords(%pixel2, 8, 11), 3) !$= "r")
					%this.pixel[8].hideNode("ALL");
				else if(getWord(getWords(%pixel2, 8, 11), 3) !$= "r")
				{
					%color = pixelRGBToDec(getWords(%pixel2, 8, 11));

					if(getWord(getWords(%pixel2, 8, 11), 3) <= 0)
						%this.pixel[8].hideNode("ALL");
					else
					{
						%this.pixel[8].setNodeColor("ALL", %color);
						%this.pixel[8].unhideNode("ALL");
					}
				}
				else
				{
					%this.pixel[8].setNodeColor("ALL", pixelRGBToDec(getWords(%pixel2, 8, 11)));
					%this.pixel[8].unhideNode("ALL");
				}
			}
		}
	}
};
activatePackage(ScreenBrick3x3OverridesPackage);